/*
  Copyright (C) 2007 National Institute For Space Research (INPE) - Brazil.

  This file is part of TerraMA2 - a free and open source computational
  platform for analysis, monitoring, and alert of geo-environmental extremes.

  TerraMA2 is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 3 of the License,
  or (at your option) any later version.

  TerraMA2 is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with TerraMA2. See LICENSE. If not, write to
  TerraMA2 Team at <terrama2-team@dpi.inpe.br>.
*/

/*!
  \file terrama2/Config.hpp

  \brief TerraMA2 configuration options.

  \author Gilberto Ribeiro de Queiroz
 */

/*!
  \mainpage TerraMA2 Code Documentation

  TerraMA2 is a free and open source computational platform for analysis, monitoring, and alert of geo-environmental extremes.

  TerraMA2 is built on top of TerraLib, a C++ software library designed for developing Geographical Information Systems (GIS).
  
  TerraMA2 and TerraLib are both developed by the National Institute for Space Research (INPE), Brazil.

  TerraMA2 is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 3 of the License,
  or (at your option) any later version.

  TerraMA2 is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with TerraMA2. See LICENSE. If not, write to
  TerraMA2 Team at <terrama2-team@dpi.inpe.br>.

  For more information about download, build and install, see the TerraMA2
  Wiki Page at <www.dpi.inpe.br/terrama2> or contact the TerraMA2 Team at <terrama2-team@dpi.inpe.br>.
 */

#ifndef __TERRAMA2_CONFIG_HPP__
#define __TERRAMA2_CONFIG_HPP__

// include real TerraMa2 config file
// generated by CMake at build configuration
#include "terrama2_config.hpp"

#endif // __TERRAMA2_CONFIG_HPP__
