/*
  Copyright (C) 2007 National Institute For Space Research (INPE) - Brazil.

  This file is part of TerraMA2 - a free and open source computational
  platform for analysis, monitoring, and alert of geo-environmental extremes.

  TerraMA2 is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 3 of the License,
  or (at your option) any later version.

  TerraMA2 is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with TerraMA2. See LICENSE. If not, write to
  TerraMA2 Team at <terrama2-team@dpi.inpe.br>.
*/

/*!
  \file terrama2/terrama2_version.hpp

  \brief TerraMA2 version information.

  \author Gilberto Ribeiro de Queiroz
 */

#ifndef __TERRAMA2_TERRAMA2_VERSION_HPP__
#define __TERRAMA2_TERRAMA2_VERSION_HPP__

//! Major version of TerraMA2 (or version).
const uint32_t TERRAMA2_VERSION_MAJOR = 4;

//! Minor version of TerraMA2 (or revision).
const uint32_t TERRAMA2_VERSION_MINOR = 0;

//! Patched version of TerraMA2 (or patch).
#define TERRAMA2_VERSION_PATCH 0

//! Release status: alpha, beta, rc (release candidate), stable.
const std::string TERRAMA2_VERSION_STATUS = "rc";

//! A string description of TerraMA2 version.
const std::string TERRAMA2_VERSION_STRING = "4.0.0-rc2";

//! TerraMA2 version.
const uint32_t TERRAMA2_VERSION = 0x040000;

#endif  // __TERRAMA2_TERRAMA2_VERSION_HPP__
